﻿import flash.external.*;
import flash.geom.Point;
#include "mtx33.as"

function IR (wiimote) {
	var a:Number = 0;
	var b:Number = 0;
	var wcZ:Number = 0;
	var wcX:Number = 0;
	var rad:Number = 0;
	var yubi:Point = new Point(0, 0);
	var yubi1:Point = yubi.clone();
	var yubi2:Point = yubi.clone();
	var yubi3:Point = yubi.clone();
	var yubi4:Point = yubi.clone();
	var pDist:Point = yubi.clone();
	var p0:Point = yubi.clone();
	var p1:Point = yubi.clone();
	var p2:Point = yubi.clone();
	var point:Object = new Object();
	var angle:Number = 0;
	var angle2:Number = 0;
	var stageW:Number = 550;
	var stageH:Number = 400;

	point._visible = true;

	a = wiimote.p2cX - wiimote.p1cX;
	b = (1 - wiimote.p2cY) - (1 - wiimote.p1cY);

	wcZ = wiimote.wcZ;
	wcX = wiimote.wcX;
	
	//加速度1以上のときは1、-1以下のときは-1に
	if (Math.abs(wiimote.wcZ) >= 1) {
		wcZ = 1;
		if ( wiimote.wcZ <0) {
			wcZ *= -1
		}
	}
	if (Math.abs(wiimote.wcX) >= 1) {
		wcX = 1;
		if ( wiimote.wcX <0) {
			wcX *= -1
		}
	}

	rad = Math.atan2(wcZ, wcX);
	angle =  -rad * 180 / Math.PI + 90;
	if (angle > 180) {
		angle -= 360;
	}
	
	if (wiimote.p1Found == true && wiimote.p2Found == true) {
		//LEDが左右とも表示されている場合;
		yubi1.x = wiimote.p1cX;
		yubi1.y = wiimote.p1cY;
		yubi2.x = wiimote.p2cX;
		yubi2.y = wiimote.p2cY;
		//中点を求める;
		yubi = Point.interpolate(yubi1, yubi2, 0.5);
		//角度を求める;
		var pTemp:Point = yubi1.subtract(yubi2);
		angle2 = Math.atan2(pTemp.y, pTemp.x)/Math.PI*180;
		//リモコンの角度と2点のLEDから求めた角度の差から描画が180度回転してしまう現象を防止
		if ( Math.abs(angle2-angle) > 170) {
			angle2 += 180;			
		}
		point._rotation = angle2;
	}
	else if( wiimote.p1Found == true) {
		//LED1のみ
		pDist = new Point(yubi1.x-wiimote.p1cX, yubi1.y-wiimote.p1cY);
		yubi1.x = wiimote.p1cX;
		yubi1.y = wiimote.p1cY;
		yubi = yubi.subtract(pDist);
		point._rotation = angle;			
	}
	else if( wiimote.p2Found == true){
		//LED2のみ
		pDist = new Point(yubi2.x-wiimote.p2cX, yubi2.y-wiimote.p2cY);
		yubi2.x = wiimote.p2cX;
		yubi2.y = wiimote.p2cY;
		yubi = yubi.subtract(pDist);
		point._rotation = angle;			
	}
	else{
		point._visible = false;
	}
	
	//画面サイズに合うように座標を変更
	p0.x = stageW-yubi.x*stageW;
	p0.y = yubi.y*stageH;
	p1.x = stageW-yubi1.x*stageW;
	p1.y = yubi1.y*stageH;
	p2.x = stageW-yubi2.x*stageW;
	p2.y = yubi2.y*stageH;

	var m1 = _root.Mtx33Translate((-stageW/2), (-stageH/2));    // 移動成分
	if (wiimote.p1Found == true && wiimote.p2Found == true) {
		var m2 = _root.Mtx33Rotate(angle2);             // 回転成分
	}
	else {
		var m2 = _root.Mtx33Rotate(angle);             // 回転成分
	}
	var m3 = _root.Mtx33Translate((stageW/2), (stageH/2));    // 移動成分

	var m4 = _root.Mtx33Transform(m1 ,m2);      // 合成
	m4 = _root.Mtx33Transform(m4 ,m3);          // 合成
	
	var vec1 = _root.Vec2dTransformPoint(p0.x, p0.y, m4);

	var vec1yubi1 = _root.Vec2dTransformPoint(p1.x, p1.y, m4);
	var vec1yubi2 = _root.Vec2dTransformPoint(p2.x, p2.y, m4);

	p0.x = vec1.x;
	p0.y = vec1.y;
	p1.x = vec1yubi1.x;
	p1.y = vec1yubi1.y;
	p2.x = vec1yubi2.x;
	p2.y = vec1yubi2.y;
		
	point._x = p0.x;
	point._y = p0.y;
	
	//オブジェクトを返す
	return point;
}